#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>
#include "ModifierApi.h"

//Modifier Information
static const char	* 	g_szName			= "YourModifierName";
static const char	*	g_szFriendlyName	= "Your modifier name";
static const char	* 	g_szAuthor			= "Your Name";
static const char	* 	g_szDescription		= "Your modifier description";
static HINSTANCE		g_hDllInstance		= NULL;

EXPORT_PSM const char 	* 	GetName()			{ return g_szName; }
EXPORT_PSM const char	*	GetFriendlyName()	{ return g_szFriendlyName; }
EXPORT_PSM const char 	* 	GetAuthor()			{ return g_szAuthor; }
EXPORT_PSM const char 	* 	GetDescription()	{ return g_szDescription; }
EXPORT_PSM PSMVERSION		GetModifierVersion(){ return MakePsmVersion(1,0); }
EXPORT_PSM PSMVERSION		GetApiVersion()		{ return MODIFIER_API_VERSION; }

EXPORT_PSM void OnInstall()
{
	//[Optional]
}

EXPORT_PSM void OnUnInstall()
{
	//[Optional]
}

EXPORT_PSM bool ConfigureModifier(HWND hParent)
{
	//[Optional]
	//return true if success, false otherwise
}

EXPORT_PSM HPSMI CreateInstance(HPSF hRomFile,HWND hParent)
{
	//return an handle to the new instance
}

EXPORT_PSM void DestroyInstance(HPSMI hInstance)
{	
}

EXPORT_PSM HPSMI LoadInstance(HPSF hRomFile,PSM_MEMORY_BLOCK MemBlock)
{
	//return an handle to the new instance
}

EXPORT_PSM bool SaveInstance(HPSMI hInstance,PSM_MEMORY_BLOCK MemBlock)
{
	//return true if success, false otherwise
}

EXPORT_PSM const char * GetInstanceName(HPSMI hInstance)
{
	//return the instance name
}

EXPORT_PSM bool ConfigureInstance(HPSMI hInstance,HWND hParent)
{
	//[Optional]
	//return true if success, false otherwise
}

EXPORT_PSM bool ApplyModifier(HPSMI hInstance,PSM_MEMORY_BLOCK MemBlock)
{		
	//return true if success, false otherwise
}


BOOL APIENTRY DllMain(HINSTANCE hInstance,DWORD  ul_reason_for_call,LPVOID lpReserved)
{
	if (ul_reason_for_call == DLL_PROCESS_ATTACH)
	{
		g_hDllInstance = hInstance;
	}
	return TRUE;
}